/* 
 * Copyright (c) 2000-2001, catchy.net. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      - Redistributions of source code must retain the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer.
 * 
 *      - Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials
 *      provided with the distribution.
 * 
 *      - All advertising materials mentioning features or use of this
 *      software must display the following acknowledgement: This
 *      product includes software developed by catchy.net and its
 *      contributors.
 * 
 *      - Neither name of catchy.net nor the names of its contributors
 *      may be used to endorse or promote products derived from this
 *      software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY CATCHY.NET AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL CATCHY.NET OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * 
 * $Id: GtkEntryPeer.cpp,v 1.1 2001/03/11 08:43:40 pascal Exp $ 
 */

#include <stdio.h>
#include <gnome.h>

#include "../../renderer/GUIPeer.h"
#include "GtkEntryPeer.h"

GtkEntryPeer::GtkEntryPeer(GtkWidget *canvas) {
  
  /* Create a text entry field. */
  pointer = gtk_entry_new();

  /* Put the text entry field somewhere in a hopefully invisible
     place on the canvas. */
  gtk_layout_put(GTK_LAYOUT(canvas), GTK_WIDGET(pointer), -1000, -1000);

  /* Display the widget and process events to get the widget's
     size. */
  gtk_widget_show(GTK_WIDGET(pointer));
  while(gtk_events_pending())
    gtk_main_iteration_do(0);

  /* Gotcha. */
  width = GTK_WIDGET(pointer)->allocation.width;
  height = GTK_WIDGET(pointer)->allocation.height;

}
 
GtkEntryPeer::~GtkEntryPeer() {

  gtk_widget_destroy(GTK_WIDGET(pointer));

}
