/* 
 * Copyright (c) 2000-2001, catchy.net. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      - Redistributions of source code must retain the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer.
 * 
 *      - Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials
 *      provided with the distribution.
 * 
 *      - All advertising materials mentioning features or use of this
 *      software must display the following acknowledgement: This
 *      product includes software developed by catchy.net and its
 *      contributors.
 * 
 *      - Neither name of catchy.net nor the names of its contributors
 *      may be used to endorse or promote products derived from this
 *      software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY CATCHY.NET AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL CATCHY.NET OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * 
 * $Id: ParserWindow.cpp,v 1.2 2001/03/14 13:35:48 wouter Exp $ 
 */

#include "windows.h"
#include "resource.h"
#include "../../../lib/String.h"
#include "../../../wmlparser/WMLParser.h"

LRESULT CALLBACK ParseDialogBox(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE instance,
                     HINSTANCE prevInstance,
                     LPSTR     cmdLine,
                     int       cmdShow) {

  DialogBox(instance, (LPCTSTR)PARSE_BOX, NULL, (DLGPROC)ParseDialogBox);
  return 0;

}

LRESULT CALLBACK ParseDialogBox(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam) {
	
  switch (message) {
  	
  case WM_INITDIALOG:
    SendMessage(GetDlgItem(hDlg, SOURCE_WINDOW),WM_SETTEXT,0,(WPARAM)"\
<?xml version=\"1.0\"?>\r\n\
<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.2//EN\"\r\n\
 \"http://www.wapforum.org/DTD/wml12.dtd\">\r\n\
<wml>\r\n\
 <template>\r\n\
  <do type = \"123\">\r\n\
   <prev/>\r\n\
  </do>\r\n\
 </template>\r\n\
 <card id=\"first\">\r\n\
  <onevent type=\"onenterforward\">\r\n\
   <refresh>\r\n\
    <setvar name=\"startCur\" value=\"\"/>\r\n\
    <setvar name=\"endCur\" value=\"\"/>\r\n\
    <setvar name=\"cur\" value=\"\"/>\r\n\
   </refresh>\r\n\
  </onevent>\r\n\
  <p>\r\n\
    <img src=\"123\" alt=\"123\"/>\r\n\
   <do type=\"accept\" label=\"conv\">\r\n\
    <go href=\"#destVal\"/>\r\n\
   </do>\r\n\
   Currency converter! &gt;&amp;\r\n\
   Convert from?<![CDATA[&gt;<tag>&amp;]]><br/>\r\n\
   <select name=\"startCur\">\r\n\
    <option  value=\"USD\">USD</option>\r\n\
    <option  value=\"DMark\">D-Mark</option>\r\n\
    <option  value=\"Franc\">Franc</option>\r\n\
    <option  value=\"Lira\">Lira</option>\r\n\
   </select>\r\n\
   <anchor><go href=\"somewhere\"/>link</anchor>\r\n\
  </p>\r\n\
 </card>\r\n\
</wml>\r\n\
");
    return TRUE;

  case WM_COMMAND:			
    if(LOWORD(wParam) == IDCANCEL) {     /* close the window*/

			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;

		}
    if(LOWORD(wParam) == PARSE_BUTTON) { /* user pushed the parse button */


      int textLength = SendMessage(GetDlgItem(hDlg, SOURCE_WINDOW),WM_GETTEXTLENGTH,0,0)+1;
      char* text = new char[textLength];
      SendMessage(GetDlgItem(hDlg, SOURCE_WINDOW),WM_GETTEXT,textLength,(WPARAM)text);

      String* s = new String(text);
      delete text;

      WMLParser* parser = new WMLParser(s);

      parser->getParseTreeAsString(s);

      delete parser;

      s->makeDosText();

      SendMessage(GetDlgItem(hDlg, PARSETREE_WINDOW),WM_SETTEXT,0,(WPARAM)s->getPtr());

      delete s;

      
    }
    break;
  }
  return FALSE;

}

