/* 
 * Copyright (c) 2000-2001, catchy.net. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      - Redistributions of source code must retain the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer.
 * 
 *      - Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials
 *      provided with the distribution.
 * 
 *      - All advertising materials mentioning features or use of this
 *      software must display the following acknowledgement: This
 *      product includes software developed by catchy.net and its
 *      contributors.
 * 
 *      - Neither name of catchy.net nor the names of its contributors
 *      may be used to endorse or promote products derived from this
 *      software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY CATCHY.NET AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL CATCHY.NET OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * 
 * $Id: About.cpp,v 1.1 2001/03/09 14:41:56 pascal Exp $ 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "OutOfMemoryException.h"
#include "About.h"
#include "URI.h"

/**
 * Creates the About object.
 */
About::About() {
}

/**
 * Destroys the About object.
 */
About::~About() {
}

/**
 * Generates the relevant information given an about: URI.
 * @throws OutOfMemoryException if some memory could not be allocated.
 * @param u the URI.
 * @param m the monitor.
 * @param r the ContentSinkResult to store the results in.
 */
void About::get(URI *u, Monitor *m, ContentSinkResult *r) {

  if(strcmp(u->getOpaquePart(), "blank") == 0) {

   r->setContent("<wml><card><p></p></card></wml>");

  } else {

    r->setContent("<wml><card><p><b>Leona</b>, I want to <i>CONFESS</i> things to you ... I want to <i>WRAP</i> you in a <i><b>SCARLET ROBE</b></i> trimmed with <big>POLYVINYL CHLORIDE</big> ... I want to <b>EMPTY</b> your <b>ASHTRAYS</b>!!</p></card></wml>");

  }

}
