/* 
 * Copyright (c) 2000-2001, catchy.net. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *      - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * 
 *      - Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 *      - All advertising materials mentioning features or use of this software
 *      must display the following acknowledgement: This product includes
 *      software developed by catchy.net and its contributors.
 * 
 *      - Neither name of catchy.net nor the names of its contributors may
 *      be used to endorse or promote products derived from this software
 *      without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY CATCHY.NET AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL CATCHY.NET OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * $Id: MobilizerPreferences.cpp,v 1.1 2001/03/11 08:43:40 pascal Exp $
 */

#include "MobilizerPreferences.h"

/** 
 * Constructs a new MobilizerPreferences object.
 */
MobilizerPreferences::MobilizerPreferences() {

  linkColor = 0x00f00000;    /* blue   */
  topLinkColor = 0x00e000b0; /* purple */

}

/**
 * Delete the object
 */
MobilizerPreferences::~MobilizerPreferences() {
}

/**
 * This function tests the code of this class
 *
 * @return      true when all tests succeed, otherwise false
 */
bool MobilizerPreferences::test() {

  MobilizerPreferences mp,mp2;

  if(mp.getPreference(prefLinkColor)    != mp2.getPreference(prefLinkColor   )) 
    return false;
  if(mp.getPreference(prefTopLinkColor) != mp2.getPreference(prefTopLinkColor)) 
    return false;

  return true;

}

/**
 * This function returns the value of the preference in the argument.
 *
 * @param  pref  the MobilizerPreferences::prefs
 * @return       the value of the preference
 */
int MobilizerPreferences::getPreference(prefs p) {

  if(p == prefLinkColor)
    return linkColor;
  
  if(p == prefTopLinkColor)
    return topLinkColor;

  return 0;

}
