/* 
 * Copyright (c) 2000-2001, catchy.net. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *      - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * 
 *      - Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 *      - All advertising materials mentioning features or use of this software
 *      must display the following acknowledgement: This product includes
 *      software developed by catchy.net and its contributors.
 * 
 *      - Neither name of catchy.net nor the names of its contributors may
 *      be used to endorse or promote products derived from this software
 *      without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY CATCHY.NET AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL CATCHY.NET OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * $Id: WMLGUIElement.h,v 1.5 2001/03/08 16:18:50 wouter Exp $
 */

#ifndef __WMLGUIELEMENT_H__
#define __WMLGUIELEMENT_H__

#include "GUIPeer.h"

#include "../lib/String.h"

/**
 * This class represents an element in the wml render window which can 
 * handle user input, like input or select boxes. The platform 
 * dependent render class, which was subclassed from 
 * WindowDrawingInterface, uses this class to get the dimensions of
 * the element.
 */
class WMLGUIElement {

public:

  WMLGUIElement(GUIPeer *gp, int identifier);
  ~WMLGUIElement();
  int getId();
  int getXCoordinate();
  int getYCoordinate();
  int getWidth();
  int getHeight();
  void setXCoordinate(int x);
  void setYCoordinate(int y);
  GUIPeer *getPeer();

private:
  int id;           /**< the identifier of the element */
  int x;            /**< the x coordinate */
  int y;            /**< the y coordinate */
  GUIPeer *peer;    /**< pointer to a platform dependent object that 
                         must be deleted when then object is
                         removed from the current page */

};

#endif
